//
// Created by william on 12/07/24.
//

#include "nametable_window.h"

void nametable_window_init(NesNametableWindow *window) {
    int win_size = pattern_display_get_size(NW_ROW_TILE_COUNT);
    window->sdl_context = window_init("Nametable", win_size, win_size, NW_SCALE);

    pattern_display_init(&window->pattern_display, window->sdl_context.renderer, NW_ROW_TILE_COUNT, NW_ROW_TILE_COUNT);
}

void nametable_window_uninit(NesNametableWindow *window) {
    pattern_display_uninit(&window->pattern_display);
    window_uninit(window->sdl_context);
}

void nametable_window_build_table(NesNametableWindow *window, byte *nametable_memory) {
    pattern_display_build(&window->pattern_display, nametable_memory);
}

void nametable_window_render(NesNametableWindow *window) {
    SDL_RenderClear(window->sdl_context.renderer);
    pattern_display_render(&window->pattern_display, window->sdl_context.renderer);
}

void nametable_window_present(NesNametableWindow *window) {
    SDL_RenderPresent(window->sdl_context.renderer);
}